#ifndef C2V_H 
#define C2V_H
/** \file Generic Macros to convert strings to vectors of numbers.
*/
/*

   $Log: c2v.h,v $
   Revision 1.1.1.1  2009/05/07 12:58:11  kraemer


   Revision 1.2.2.2  2009/05/07 11:16:57  kraemer
   64bit-clean, allow tabs

   Revision 1.2.2.1  2005/03/15 14:25:54  kraemer
   *** empty log message ***

   Revision 1.2  2000/07/25 14:35:52  kraemer
   abs()=>fabs() fixes trouble with DUX 4.0

   Revision 1.1  2000/04/03 12:29:09  kraemer
   *** empty log message ***

    
*/

#include "ustr.h"
#define STRNTRIMTAB(pc,nc) while((nc>0L)&&((*pc==' ')||(*pc=='\t'))){nc--;pc++;}while((nc>0L)&&((pc[nc-1L]==' ')||(pc[nc-1L]=='\t')))nc--;

                                      /* error codes */   
enum { C2VERR_CONV=1L, C2VERR_OFLO, C2VERR_SYNTAX, C2VERR_BADSTEP };
                                      /* character classes */   
enum { C2V_NULL=0L, C2V_SPACE, C2V_COMMA, C2V_PAR, C2V_ITEM, C2V_MAXCHAR };

#define C2VInteger(TYPE,DST,FCT) \
   static signed char bTable[C2V_MAXCHAR][MSTATE] = {\
/*        STA NUM TBL TB2 TCM SEP REP RBL LBL */ \
/* \0  */ STP,SEP,STP,STP,STP,SEP/*STP*/,Err,Err,SEP,\
/* ' ' */ STA,TBL,TB2,TB2,TCM,LBL/*NUM*/,RBL,RBL,LBL,\
/*  ,  */ SEP,SEP,TCM,TCM,SEP,SEP,Err,Err,SEP,\
/* (   */ REP,Err,REP,REP,REP,REP,Err,Err,REP,\
/* else*/ NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,\
   };\
   int iChar, iState = STA;\
   ssize_t iRC;\
   size_t nn = 0L, ii, nc=0L;\
   char *pc; char cc;\
   TYPE valStep[3] = {0,0,1}, val;\
\
   if ( pcStr == NULL ) return(0L);\
                                      /* */ \
   STRNTRIMTAB(pcStr,ncStr);\
                                      /* equidistant */\
   if ( pc = strnistr( pcStr, ncStr, "TO" ) ) {\
                                      /* pickup <start> */\
      nc = pc - pcStr;\
      if ( ( iRC= FCT( pcStr, nc, & valStep[0] ) ) != 0L ) return(-C2VERR_CONV);\
                                      /* skip over "TO" */\
      pcStr = pc + 2L; ncStr -= nc+2L;\
      if ( pc = strnistr( pcStr, ncStr, "BY" ) ) {\
         nc = pc - pcStr;\
         iRC= FCT( pcStr, nc, & valStep[1] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
         pcStr = pc + 2L; ncStr -= nc+2L;\
         iRC= FCT( pcStr, ncStr, & valStep[2] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
      } else {\
         iRC= FCT( pcStr, ncStr, & valStep[1] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
         valStep[2] = 1;\
      }\
      if ( valStep[2] == 0 ) return(-C2VERR_BADSTEP);\
                                      /* handle increasing/decreasing */\
      if ( valStep[1] >= valStep[0] ) {\
         valStep[2] =    abs( valStep[2] );\
         for( val=valStep[0]; val<=valStep[1]; val+=valStep[2] ) {\
           if ( DST ) { *DST = val; DST += iStride; } nn++;\
           if ( nn >= nv ) break;\
         }\
      } else {\
         valStep[2] = -( abs( valStep[2] ) );\
         for( val=valStep[0]; val>=valStep[1]; val+=valStep[2] ) {\
           if ( DST ) { *DST = val; DST += iStride; } nn++;\
           if ( nn >= nv ) break;\
         }\
      }\
                                      /* list of values */\
   } else {\
      int32_t lRep = 1;\
      pc = (char *) pcStr;\
      do {\
                                      /* if string exhausted, simulate nullbyte */\
         if ( ncStr == 0 ) cc = '\0';\
         else              cc = *pcStr;\
                                      /* char class */\
         switch(cc) {\
         case '\0': iChar = C2V_NULL; break;\
         case ' ':  case '\t':  iChar = C2V_SPACE; break;\
         case ',':  iChar = C2V_COMMA; break;\
         case '(':  iChar = C2V_PAR; break;\
         default:   iChar = C2V_ITEM;  break;\
         }\
\
         iState = bTable[iChar][iState];\
         switch(iState) {\
         case STA: case LBL: case STP: break;\
         case NUM: break;\
         case TB2: break;\
         case RBL: break;\
                                      /* break out repetition factor */\
         case REP:\
            ii = 0; pc = (char *) pcStr;\
            while( *pc && (ncStr>0) ) {\
               if ( *pc == '(' ) ii++;\
               if ( *pc == ')' ) ii--;\
               if ( ii == 0 ) break;\
               pc++;ncStr--;\
            }\
            if ( ii != 0 ) return(-C2VERR_SYNTAX);\
            if ( ( ii = pc - pcStr ) <= 0 )\
               return(-C2VERR_SYNTAX);\
            if ( cn2l( pcStr+1, ii-1, &lRep ) != 0 ) return(-C2VERR_SYNTAX);\
            pcStr = pc; /*ncStr -= ii;*/ pc = (char *) pcStr+1;\
         break;\
         case TCM: pc = (char *) pcStr+1; break;\
         case TBL: case SEP:\
            nc = pcStr - pc;\
            if ( ( iRC= FCT( pc, nc, &val ) ) < 0 ) return(-C2VERR_CONV);\
            while ( lRep-- ) {\
               nn++;\
               if (DST) { if (iRC==0) *DST = val; DST += iStride; };\
               if ( nn >= nv ) return(nn);\
            }\
            pc = (char *) pcStr+1; lRep = 1;\
         break;\
         default: return(-C2VERR_SYNTAX); break;\
         }\
         pcStr++;\
      } while(ncStr--);\
   }\
   return(nn);


#define C2VFloat(TYPE,DST,FCT) \
   static signed char bTable[C2V_MAXCHAR][MSTATE] = {\
/*        STA NUM TBL TB2 TCM SEP REP RBL LBL */ \
/* \0  */ STP,SEP,STP,STP,STP,SEP/*STP*/,Err,Err,SEP,\
/* ' ' */ STA,TBL,TB2,TB2,TCM,LBL/*NUM*/,RBL,RBL,LBL,\
/*  ,  */ SEP,SEP,TCM,TCM,SEP,SEP,Err,Err,SEP,\
/* (   */ REP,Err,REP,REP,REP,REP,Err,Err,REP,\
/* else*/ NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,\
   };\
   int iChar, iState = STA;\
   ssize_t iRC;\
   size_t nn = 0L, ii, nc=0L;\
   char *pc; char cc;\
   TYPE valStep[3] = {0,0,1}, val;\
\
   if ( pcStr == NULL ) return(0L);\
                                      /* */ \
   STRNTRIMTAB(pcStr,ncStr);\
                                      /* equidistant */\
   if ( pc = strnistr( pcStr, ncStr, "TO" ) ) {\
                                      /* pickup <start> */\
      nc = pc - pcStr;\
      if ( ( iRC= FCT( pcStr, nc, & valStep[0] ) ) != 0L ) return(-C2VERR_CONV);\
                                      /* skip over "TO" */\
      pcStr = pc + 2L; ncStr -= nc+2L;\
      if ( pc = strnistr( pcStr, ncStr, "BY" ) ) {\
         nc = pc - pcStr;\
         iRC= FCT( pcStr, nc, & valStep[1] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
         pcStr = pc + 2; ncStr -= nc+2;\
         iRC= FCT( pcStr, ncStr, & valStep[2] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
      } else {\
         iRC= FCT( pcStr, ncStr, & valStep[1] );\
         switch ( iRC ) {\
         case 0:\
         break;\
         case 1:\
            return(-C2VERR_SYNTAX);\
         break;\
         default:\
            return(-C2VERR_CONV);\
         break;\
         }\
         valStep[2] = 1;\
      }\
      if ( valStep[2] == 0 ) return(-C2VERR_BADSTEP);\
                                      /* handle increasing/decreasing */\
      if ( valStep[1] >= valStep[0] ) {\
         valStep[2] =   fabs( valStep[2] );\
         nn = (size_t) ( ( valStep[1] - valStep[0] ) / valStep[2] ) + 1;\
         nn = min(nn,nv);\
         val = valStep[0];\
         for( ii=0;ii<nn;ii++  ) {\
            if ( DST ) { *DST = val; DST += iStride; }\
            val += valStep[2];\
         }\
      } else {\
         valStep[2] = -( fabs( valStep[2] ) );\
         nn = (size_t) fabs( ( valStep[1] - valStep[0] ) / valStep[2] ) + 1;\
         nn = min(nn,nv);\
         val = valStep[0];\
         for( ii=0;ii<nn;ii++  ) {\
            if ( DST ) { *DST = val; DST += iStride; }\
            val += valStep[2];\
         }\
      }\
                                      /* list of values */\
   } else {\
      int32_t lRep = 1;\
      pc = (char *) pcStr;\
      do {\
                                      /* if string exhausted, simulate nullbyte */\
         if ( ncStr == 0 ) cc = '\0';\
         else              cc = *pcStr;\
                                      /* char class */\
         switch(cc) {\
         case '\0': iChar = C2V_NULL; break;\
         case ' ': case '\t': iChar = C2V_SPACE; break;\
         case ',':  iChar = C2V_COMMA; break;\
         case '(':  iChar = C2V_PAR; break;\
         default:   iChar = C2V_ITEM;  break;\
         }\
\
         iState = bTable[iChar][iState];\
         switch(iState) {\
         case STA: case LBL: case STP: break;\
         case NUM: break;\
         case TB2: break;\
         case RBL: break;\
                                      /* break out repetition factor */\
         case REP:\
            ii = 0; pc = (char *) pcStr;\
            while( *pc && ( ncStr > 0 ) ) {\
               if ( *pc == '(' ) ii++;\
               if ( *pc == ')' ) ii--;\
               if ( ii == 0 ) break;\
               pc++;ncStr--;\
            }\
            if ( ii != 0 ) return(-C2VERR_SYNTAX);\
            if ( ( ii = pc - pcStr ) <= 0 )\
               return(-C2VERR_SYNTAX);\
            if ( cn2l( pcStr+1, ii-1, &lRep ) != 0 ) return(-C2VERR_SYNTAX);\
            pcStr = pc; /*ncStr -= ii;*/ pc = (char *) pcStr+1;\
         break;\
         case TCM: pc = (char *) pcStr+1; break;\
         case TBL: case SEP:\
            nc = pcStr - pc;\
            if ( ( iRC= FCT( pc, nc, &val ) ) < 0 ) return(-C2VERR_CONV);\
            while ( lRep-- ) {\
               nn++;\
               if (DST) { if (iRC==0) *DST = val; DST += iStride; };\
               if ( nn >= nv ) return(nn);\
            }\
            pc = (char *) pcStr+1; lRep = 1;\
         break;\
         default: return(-C2VERR_SYNTAX); break;\
         }\
         pcStr++;\
      } while(ncStr-->0);\
   }\
   return(nn);

#endif
