#ifndef CMDERR_H
#define CMDERR_H
/** \file Definitions for error messaging.
*/
/*

   Copyright  (C) 1992-2010 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved

   $Log: cmderr.h,v $
   Revision 1.1.1.1  2009/05/08 00:34:35  kraemer


   Revision 1.1.1.1.2.2  2009/05/08 00:13:46  kraemer
   64bit-clean, large files

   Revision 1.1.1.1.2.1  2005/03/15 14:57:18  kraemer
   *** empty log message ***

   Revision 1.1.1.1  1999/02/02 20:13:13  kraemer


*/

#include <sys/types.h>
                                      /* */
                                      /** \struct SCMDERR
                                          \brief Error handling.
                                      */ 
struct SCMDERR {
   int iRC;                           /**< base error code */
   int iSev;                          /**< severity level (error/warning) */
#define CMDERR_MASK    0xFF000000
#define CMDERR_ERROR   0x80000000
#define CMDERR_WARNING 0x40000000
   char *pcFile; off_t iLine;         /**< optional: file name, line number causing an error */
   char *pcMsg; size_t ncMsg;         /**< optional: extra text, length */
   char *pcLine; size_t ncLine; ssize_t iOffs;   /**< optional: error line, length, offset */ 
   char *pcFct;                       /**< optional: function causing the error */
   char *pcErr;                       /**< error message for error code (system or application) */
};
                                      /*  */
#define CMDERR_DEBUG   0x80000000      
                                      /* some useful macros */
#define CMDERRINIT(s) memset( &(s), 0, sizeof((s)) ); (s).iRC=ERRCMDERR_SYS; (s).iSev=CMDERR_ERROR; (s).iOffs=-1;
#define CMDERRGOTO(sto,sfr,gError) { (sto).iRC=(sfr).iRC; (sto).iSev=(sfr).iSev; goto gError; }
                                      /* error codes */
enum { ERRCMDERR_SYS=1,               /* ! reserved for runtime errors */
       ERRCMDERR_BADADDR,
};
/*
   _cmderrInit   ( ce, flags )
                 o initializes an error structure
                 o to test (formally)
                 
   _cmderrMsg    ( ce, flags )
                 o error message output
                 o to test (formally)
                 
   _cmderrInspect( ce, flags )
                 o inspect output
                 o to test (formally)

*/
                                      /* function prototypes */
int _cmderrInit   ( struct SCMDERR *, unsigned int );
int _cmderrInspect( struct SCMDERR *, unsigned int );
int _cmderrMsg    ( struct SCMDERR *, unsigned int );

#endif
