#ifndef DCMPAT_H
#define DCMPAT_H
/** \file

   Definitions to handle DICOM Patient Modules.

*/
/*

   Copyright  2005-2011 M.Kraemer, GSI, D-64291 Darmstadt

   $Log$

*/
#include "dcmbasic.h"

                                      /** \struct SDICOMREFERENCEDPATIENT
                                          \brief .
                                      */ 
struct SDICOMREFERENCEDPATIENT {
   struct SDICOMDATAELEMENT 
          *psDEReferencedSOPClassUID
         ,*psDEReferencedSOPInstanceUID
         ;
};
                                      /** \struct SDICOMOTHERPATIENTIDS
                                          \brief .
                                      */ 
struct SDICOMOTHERPATIENTIDS {
   struct SDICOMDATAELEMENT 
          *psDEPatientID
         ,*psDEIssuerofPatientID
         ,*psDETypeofPatientID
         ;
};
                                      /** \struct SDICOMPATIENTSPECIESCODE
                                          \brief .
                                      */ 
struct SDICOMPATIENTSPECIESCODE {
   struct SDICOMDATAELEMENT 
          *psDECodeValue
         ,*psDECodingSchemeDesignator
         ,*psDECodingSchemeVersion
         ,*psDECodeMeaning
         
         ,*psDEContextIdentifier
         ,*psDEMappingResource
         ,*psDEContextGroupVersion
         ,*psDEContextGroupExtensionFlag
         ,*psDEContextGroupLocalVersion
         ,*psDEContextGroupExtensionCreatorUID
         ;
};
                                      /** \struct SDICOMPATIENTBREEDCODE
                                          \brief .
                                      */ 
struct SDICOMPATIENTBREEDCODE {
   struct SDICOMDATAELEMENT 
          *psDECodeValue
         ,*psDECodingSchemeDesignator
         ,*psDECodingSchemeVersion
         ,*psDECodeMeaning
         
         ,*psDEContextIdentifier
         ,*psDEMappingResource
         ,*psDEContextGroupVersion
         ,*psDEContextGroupExtensionFlag
         ,*psDEContextGroupLocalVersion
         ,*psDEContextGroupExtensionCreatorUID
         ;
};
                                      /** \struct SDICOMBREEDREGISTRATION
                                          \brief .
                                      */ 
struct SDICOMBREEDREGISTRATION {
   struct SDICOMDATAELEMENT 
          *psDEBreedRegistrationNumber
         ,*psDEBreedRegistryCodeSequence
         ;
};
                                      /** \struct SDICOMDEIDENTIFICATIONMETHODCODE
                                          \brief .
                                      */ 
struct SDICOMDEIDENTIFICATIONMETHODCODE {
   struct SDICOMDATAELEMENT 
          *psDECodeValue
         ,*psDECodingSchemeDesignator
         ,*psDECodingSchemeVersion
         ,*psDECodeMeaning
         
         ,*psDEContextIdentifier
         ,*psDEMappingResource
         ,*psDEContextGroupVersion
         ,*psDEContextGroupExtensionFlag
         ,*psDEContextGroupLocalVersion
         ,*psDEContextGroupExtensionCreatorUID
         ;
};
                                      /** \struct SDICOMPATIENTMODULE
                                          \brief Patient Module attributes
                                                 PS 3.3 C.7.1.1 Patient Module
                                                 Table C.7-1.
                                      */ 
struct SDICOMPATIENTMODULE {
   struct SDICOMDATAELEMENT 
          *psDEPatientsName
         ,*psDEPatientID
         ,*psDEIssuerofPatientID
         ,*psDEPatientsBirthDate
         ,*psDEPatientsSex
         ,*psDEPatientsBirthTime
         ,*psDEOtherPatientIDs
         ,*psDEOtherPatientNames
         ,*psDEEthnicGroup
         ,*psDEPatientComments
         ,*psDEPatientSpeciesDescription
         ,*psDEPatientBreedDescription
         ,*psDEResponsiblePerson
         ,*psDEResponsiblePersonRole
         ,*psDEResponsibleOrganization
         ,*psDEPatientIdentityRemoved
         ,*psDEDeidentificationMethod
         ;
   int nRP;      
   struct SDICOMREFERENCEDPATIENT *psRP;      
   int nOPI;      
   struct SDICOMOTHERPATIENTIDS *psOPI;      
   int nPSC;      
   struct SDICOMPATIENTSPECIESCODE *psPSC;      
   int nPBC;      
   struct SDICOMPATIENTBREEDCODE *psPBC;      
   int nBR;      
   struct SDICOMBREEDREGISTRATION *psBR;      
   int nDMC;      
   struct SDICOMDEIDENTIFICATIONMETHODCODE *psDMC;      
};

/*

   Functions
   ---------
   
   dicomPatientModuleFree    ( rtss, flag )
                             o releases resources
                             o to do
                             o calls:
                            
   dicomPatientModuleFromDS  ( rtss, dcmds, flag )
                             o build RT structure set from DICOM file
                             o to test
                             o calls:
   
   dicomPatientModuleInit    ( rtss, flag )
                             o initialize
                             o to do
                             o calls:
                         
   dicomPatientModuleInspect ( rtss, flag )
                             o inspect 
                             o to do
                             o calls:
                         
*/
                                      /* function prototypes */
struct SCMDERR dicomPatientModuleFree    ( struct SDICOMPATIENTMODULE *, unsigned int );
//struct SCMDERR dicomPatientModuleFromFile( struct SDICOMPATIENTMODULE *, struct SDICOMFILE *, unsigned int );
struct SCMDERR dicomPatientModuleFromDS  ( struct SDICOMPATIENTMODULE *, struct SDICOMDATASET *, unsigned int );
struct SCMDERR dicomPatientModuleInit    ( struct SDICOMPATIENTMODULE *, unsigned int );
struct SCMDERR dicomPatientModuleInspect ( struct SDICOMPATIENTMODULE *, unsigned int );

struct SDICOM _dicomPatientModuleTest( unsigned int );

#endif
