#ifndef USTR_H
#define USTR_H
/** \file Definitions for string handling stuff.
*/
/*
   
   Copyright  2003-2011 M.Kraemer, D-64291 Darmstadt, Seegartenstr. 32,
                         all rights reserved
   $Log: ustr.h,v $
   Revision 1.1.1.1  2009/05/06 16:21:41  kraemer


   Revision 1.1.2.5  2009/05/06 14:13:31  kraemer
   64bit-clean

   Revision 1.1.2.4  2008/06/20 16:14:20  kraemer
   mac added

   Revision 1.1.2.3  2005/11/22 16:55:02  kraemer
   sync'ed with old U

   Revision 1.1.2.2  2005/03/11 18:31:55  kraemer
   MacOS X sync

   Revision 1.1.2.1  2005/01/31 20:40:40  kraemer
   *** empty log message ***

*/

#include <limits.h>
/* MOSX: */
#include <sys/types.h>

#include "utypes.h"

                                         /*  */
#ifndef STRNTRIM
#define STRNTRIM(pc,nc) while((nc>0L)&&(*pc==' ')){nc--;pc++;}while((nc>0L)&&(pc[nc-1L]==' '))nc--;
#endif

#ifndef NLBL
#define NLBL(pc) while( *(pc) == ' ' ) (pc)++;
#endif

#ifndef Str
#define Str(v) #v
#endif
#ifndef XStr
#define XStr(v) Str(v)
#endif


ssize_t cn2vcn( const char *, size_t, char **, size_t *, size_t, size_t );
ssize_t cn2vc (       char *, size_t, char **,           size_t, size_t );
ssize_t c2vcn ( const char *,         char **, size_t *, size_t, size_t );
ssize_t c2vc  (       char *,         char **,           size_t, size_t );

#if defined(__EMX__) || defined(AMIGA)  || defined(__APPLE_CC__)
#else
char *strlwr( char *);
char *strupr( char *);
#endif
void strnupr( char *, size_t );
 
#if defined(ultrix)
char *strdup ( const char * );
#else
#endif

void strmcpy ( char *, const char *, size_t );

char *strtrim( char *);

                                         /* special for non-standardized strnstr()  */
char *ustrnstr  ( const char *, size_t, const char *      );
#if defined(__EMX__) || defined(AMIGA)
#define ustrnstr(str,len,fnd) strnstr(str,len,fnd) 
#elif defined(__APPLE_CC__)
#define ustrnstr(str,len,fnd) strnstr(str,fnd,len) 
#endif

#if defined(__EMX__) || defined(AMIGA) || defined(__APPLE_CC__)
#else
int strnicmp( const char *, const char *, size_t );
int  stricmp( const char *, const char * );
#endif
ssize_t  stricnb  ( const char *, const char *);

char *strnpbrk ( const char *, size_t, const char *      );

char *stristr  ( const char *,         const char *      );
char *stristrn ( const char *,         const char *, size_t );
char *strnistr ( const char *, size_t, const char *      );
char *strnistrn( const char *, size_t, const char *, size_t );

char *strnchr  ( const char *, size_t, char);

int  striwld ( const char *, const char * );
int  striwldn( const char *, const char *, size_t );
int  strniwld( const char *, size_t, const char * );


char *strrepl( const char *, const char *, char * );
 
char *strndup ( const char *, size_t );
char *strndup2( const char *, size_t, const char *, size_t );
char *strndup3( const char *, size_t, const char *, size_t, const char *, size_t );

#if defined(ultrix)
char *strdup ( const char * );
#endif
char *strdup2( const char *, const char * );
char *strdup3( const char *, const char *, const char * );
char *strdup4( const char *, const char *, const char *, const char * );

#if !defined(AMIGA)
void strmfn( char [PATH_MAX+1], const char *, const char *, const char *, const char * );
void strsfn( const char *, char [PATH_MAX+1], char [PATH_MAX+1], char [PATH_MAX+1], char [PATH_MAX+1] );
void strmfp( char *, const char *, const char * );
#endif

ssize_t ugetxpr( const char *, size_t, char **, size_t *, char **, size_t *);

#endif
